# ChartObjects
#
# Class describing all the objects present in a yaml file
# generated by running 'helm template' against a Kubernetes Chart

require 'yaml'
require_relative 'rbac_defs'
require_relative 'kubernetes_subject'

class ChartObjects
  # instance variables
  attr_accessor :chart_objects
  attr_accessor :rbac_entries
  attr_accessor :kubernetes_subjects
  attr_accessor :subject_mappings

  def initialize(chart_yaml = false, subject_mappings_yaml = false)
    @chart_yaml = chart_yaml
    @subject_mappings_yaml = subject_mappings_yaml

    @chart_objects = @chart_yaml ? YAML.load_stream(File.read(@chart_yaml)) : []
    begin
      @subject_mappings = subject_mappings_yaml ? YAML.load_file(@subject_mappings_yaml) : @subject_mappings = nil
    rescue StandardError
      raise ArgumentError, "No such file exists #{@subject_mappings_yaml}"
    end

    @rbac_entries = []
    @kubernetes_subjects = []

    isolate_rbac_entries
    define_kube_subjects
  end

  def size
    @chart_objects.length
  end

  def isolate_rbac_entries
    @chart_objects.each do |chart_object|
      next unless chart_object&.key?("kind")

      @rbac_entries.push chart_object if KubeObjectDefinitions.rbac_kinds.include? chart_object["kind"]
    end
  end

  def subjects_match_remaps?
    # Nil means no remapping is happening
    return true if @subject_mappings.nil?

    subject_names = @kubernetes_subjects.map(&:subject_name)
    remap_names = @subject_mappings.keys

    return false if subject_names.length != remap_names.length

    return false if subject_names.sort != remap_names.sort

    true
  end

  def define_kube_subjects
    KubeObjectDefinitions.subjects?(@rbac_entries).each do |subject|
      current_subject = KubernetesSubject.new subject
      @kubernetes_subjects.push(current_subject) unless @kubernetes_subjects.include? current_subject
    end

    raise ArgumentError, 'account mappings and kubernetes subjects must have a 1:1 mapping' unless subjects_match_remaps?

    @kubernetes_subjects.each do |kube_subject|
      kube_subject.define_roles KubeObjectDefinitions.roles?(@rbac_entries), KubeObjectDefinitions.role_bindings?(@rbac_entries)
      kube_subject.set_name_property @subject_mappings
    end
  end
end
